Subject: Re: [PATCH 15/42] PCI: aardvark: Change name of INTx irq_chip to advk-INT

From: Marc Zyngier <[email-masked]>
Date: Mon, 24 May 2021 16:14:59 +0100

On Mon, 24 May 2021 15:36:51 +0100,
Marek Behún <[email-masked]> wrote:
> 
> On Fri, 07 May 2021 10:08:18 +0100
> Marc Zyngier <[email-masked]> wrote:
> 
> > On Thu, 06 May 2021 16:31:26 +0100,
> > Pali Rohár <[email-masked]> wrote:
> > > 
> > > This name is visible in /proc/interrupts file and for better reading it
> > > should have at most 8 characters. Also there is no need to allocate this
> > > name dynamically, since there is only one PCIe controller on Armada 37xx.
> > > This aligns with how the MSI irq_chip in this driver names it's interrupt
> > > ("advk-MSI").  
> > 
> > And *because* the name is visible in /proc/interrupts, it has become
> > an ABI, and cannot be changed anymore.
> > 
> > We had the exact same issue with Tegra this merge window as I
> > accidentally changed "Tegra" to "tegra", resulting in userspace
> > programs failing find stuff in /proc/interrupts.
> > 
> > Please keep the name as is, no matter how ugly it is.
> 
> Hmm, I am 99% sure that for the A3720 platform this ABI change would not
> affect anybody. And it does make the driver's irq names confusing.
> Can't we really do anything here?

No, this is final. Show anything in /proc/*, maintain it forever. We
already went there with the bogomips crap showing up in
/proc/cpuinfo. There is no way you can know what userspace does, and
the best course of action is not to change things for some dubious
value of "nicer" or "less confusing".

> Note that there were suggestions from some people to completely remove
> this driver due to the many problems it has which Pali is trying to
> solve. But if the driver was removed and then later introduced again
> without these problems, the new version would use the "advk-INT" IRQ
> name...

No, you would have to keep the *exact same output*. Userspace doesn't
know about drivers, and expect things in /proc to be stable.

Frankly, there are more important things to do than to worry about the
shape of /proc/interrupts. And if we could change it, I'd simply get
rid of it (you really should look at it on a system that has ~200
CPUs...).

Thanks,

	M.

-- 
Without deviation from the norm, progress is not possible.

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel